/*****************************************************************************
 * leco                                                                      *
 *****************************************************************************/

/*****************************************************************************
 * File name:     src/block.h                                                *
 * Created:       2006-07-03 by Hampa Hug <hampa@hampa.ch>                   *
 * Last modified: 2006-07-08 by Hampa Hug <hampa@hampa.ch>                   *
 * Copyright:     (C) 2006 Hampa Hug <hampa@hampa.ch>                        *
 *****************************************************************************/

/*****************************************************************************
 * This program is free software. You can redistribute it and / or modify it *
 * under the terms of the GNU General Public License version 2 as  published *
 * by the Free Software Foundation.                                          *
 *                                                                           *
 * This program is distributed in the hope  that  it  will  be  useful,  but *
 * WITHOUT  ANY   WARRANTY,   without   even   the   implied   warranty   of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU  General *
 * Public License for more details.                                          *
 *****************************************************************************/

/* $Id: block.h 48 2006-07-08 11:37:23Z hampa $ */


#ifndef LECO_BLOCK_H
#define LECO_BLOCK_H 1


#include "config.h"

#include "lstdint.h"

#include "gf.h"


extern gf_t par_gf;


void lec_block_clear (uint16_t *blk, unsigned long bsize);
void lec_block_get (uint16_t *dst, const void *src, unsigned long bsize);
void lec_block_set (void *dst, const uint16_t *src, unsigned long bsize);
void lec_block_mul (uint16_t *blk, unsigned short x, unsigned long bsize);
void lec_block_div (uint16_t *blk, unsigned short x, unsigned long bsize);
void lec_block_add (uint16_t *dst, const uint16_t *src, unsigned long bsize);
void lec_block_sub (uint16_t *dst, const uint16_t *src, unsigned long bsize);
void lec_block_muladd (uint16_t *dst, const uint16_t *src, uint16_t x, unsigned long bsize);

uint16_t lec_get_coeff (unsigned row, unsigned col);


#endif
